#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>
#include <TimedAction.h>
#include <Servo.h> 
 

//Wiring the Arduino
// pin 9 - Servo
// pin 7 - Serial clock out (SCLK)
// pin 6 - Serial data out (DIN)
// pin 5 - Data/Command select (D/C)
// pin 4 - LCD chip select (CS)
// pin 3 - LCD reset (RST)


Servo myservo;
Adafruit_PCD8544 display = Adafruit_PCD8544(7, 6, 5, 4, 3);
TimedAction timedAction = TimedAction(1000,countdown);
static int timer_value = 20; //25 minutes

void setup()   {

  // Attach servo to pin 9
  myservo.attach(9);
  // Set servo in initial position
  myservo.write(25);
  //Give it some time to get into position
  delay(1000);
  
  //Start display  
  display.begin();

  // Contrast
  display.setContrast(50);

  // Text size  
  display.setTextSize(2);
  display.setTextColor(BLACK);

  //Turn on display light
  pinMode(12, OUTPUT);
  digitalWrite(12, HIGH);
  
  // Start with a gong
  gong();
}


void loop() {
  timedAction.check();
}

void countdown() {
  timer_value--;
  
  if (timer_value < 1) {
    timedAction.disable();
    gong();
    display.clearDisplay();
    display.println("\n GONG!");
    display.display();
  }
  else
  {
    int minutes_left = timer_value/60;
    int seconds_left = timer_value % 60;
    
    // Display time
    display.clearDisplay();
    display.println("");
    display.print(" ");
    
    //Print leading zero
    if (minutes_left < 10)
      display.print("0");
    display.print(minutes_left, DEC);
    display.print(":");
    
    //Print leading zero
    if (seconds_left < 10)
      display.print("0");
    display.print(seconds_left, DEC);
    display.display();
  }
}

void gong() {
  myservo.write(65); 
  delay(80);
  myservo.write(25);
}

